# developer Account Engagement API (pardot) - Full Documentation # Account Engagement API Quick Start This tutorial walks you through a few real-life tasks so you can start automating and extending Account Engagement. In this guide, we implement authentication by using an OAuth2.0 flow, and then make some example calls and complete a basic task. Before you begin, make sure that you have: - A Salesforce admin to create an external client app and gather information. - A Salesforce user with single sign-on (SSO) enabled for Account Engagement. - A configured Account Engagement business unit. - Selected which OAuth flow works best for your case. This tutorial uses the Web Server OAuth flow. This tutorial requires knowledge of external client apps and authentication. If you aren't familiar with these topics, review the concepts in [External Client Apps](https://help.salesforce.com/s/articleView?id=xcloud.external_client_apps.htm) first. After you familiarize yourself with the basics, come back to this tutorial. **warning:** The calls you make during this tutorial have the potential to impact both your Salesforce and Account Engagement settings and data. If you’re just testing the API, make sure that you’re using a sandbox account. If you’re using this tutorial to set up your production account, use caution. ## Authentication To authenticate Account Engagement API requests, you must use an SSO-enabled Salesforce user who has Account Engagement access and an OAuth flow with an external client app. ### Step 1: Create the External Client App in Salesforce The first step in authentication is creating an external client app. An external client app is a framework that enables an external app to integrate with Salesforce by using APIs and standard protocols like OAuth. External client apps use these protocols to authenticate, authorize, and provide SSO for external apps. To put it simply, an external client app represents an integration. See [External Client Apps](https://help.salesforce.com/s/articleView?id=xcloud.external_client_apps.htm&type=5). To set up an external client app, have a Salesforce admin follow these steps: 1. From Salesforce Setup, in the Quick Find box, enter **External Client Apps**, and then select **External Client Manager**. 2. Click **New External Client App**. 3. Configure the external client app. 1. Name the external client app. 2. Add the email address for the admin who manages Agentforce. 3. From the Distribution State picklist, select **Local**. 4. In the API section, select **Enable OAuth Settings**. 5. Enter a callback URL. The callback URL is used to redirect users after authentication in browser-based flows. This example uses `https://my.example.com/myapp`. If you use a browser-based flow, such as Web Server Flow or User Agent Flow, the URL must match the URL you pass as a callback to OAuth endpoints. If you aren’t using a browser-based flow, the URL isn’t used. 6. To give the app access to Account Engagement, under **Selected OAuth Scopes**, add **Manage Pardot services**. For more complex scenarios, such as using refresh tokens, select other scopes as well. 4. Click **Create**. **note:** The external client app requires up to 15 minutes before it's available for authentication. ### Step 2: Gather Important Information Now that you have an external client app, gather some important information you need handy to finish setting up authentication. The primary details are: - External Client App Consumer Key: a unique identifier for your external client app. - External Client App Consumer Secret: a password for the external client app. - Business Unit IDs: Because a Salesforce org can have multiple business units, the ID routes the API request to the correct business unit. You need the ID even if you have only one business unit. - Salesforce User: A Salesforce user with SSO enabled for Account Engagement. Because all of this information is sensitive, carefully consider how to share these details with other team members securely. #### Find the Consumer Key and Secret 1. From Salesforce Setup, in the Quick Find box, enter **External Client**, and then select **External Client Manager**. 2. Go to your external client app and select **Settings**. 3. In the OAuth settings, click **Consumer Key and Secret**. 4. Copy your consumer key. 5. Reveal and copy your consumer secret. #### Find the Account Engagement Business Unit IDs 1. From Marketing Setup, in the Quick Find box, enter **Pardot**, and then select **Pardot Account Setup**. 2. Copy the business unit ID for the Account Engagement instance you want to use. #### Choose the Integration User For the integration user, we recommend that you create a unique user for each specific app integration. The user must be SSO-enabled and have access to Account Engagement. ### Step 3: Implement OAuth Flow Salesforce has several OAuth flows to meet your unique security and integration needs. In this tutorial, we use the [Web Server OAuth flow](https://help.salesforce.com/articleView?id=sf.remoteaccess_oauth_web_server_flow.htm). This flow is ideal for when you don’t want to store the end user’s credentials in your system. To learn more about your options and how to choose the best OAuth flow for your integration, check out [Salesforce OAuth Help Documentation](https://help.salesforce.com/articleView?id=sf.remoteaccess_authenticate.htm). 1. Have your integration direct the user to Salesforce’s OAuth authorization endpoint: `https://login.salesforce.com/services/oauth2/authorize?response_type=code&client_id=CLIENT_ID&redirect_uri=https://my.example.com/myapp` - Replace `CLIENT_ID` with your external client app consumer key. - Replace `https://my.example.com/myapp` with your redirect URI. 2. If the user doesn’t have an active session, they’re prompted to log into Salesforce. 3. The user grants the app permission. 4. After the user has logged in and allowed the app, Salesforce redirects you back to the `redirect_uri` passed in to the `authorize` endpoint:`https://my.example.com/myapp?code=` 5. Your server-side code exchanges this code for an access token by making a POST request to the Salesforce OAuth token endpoint: ``` POST /services/oauth2/token HTTP/1.1 Host: login.salesforce.com Content-type: application/x-www-form-urlencoded grant_type=authorization_code& code=& client_id=& client_secret=& redirect_uri=https://my.example.com/myapp ``` 6. After Salesforce validates the external client app credentials and authorization code, the endpoint responds with an access token: ```json { "Access_token": "", "signature": "", "instance_url": "https://MyDomainName.my.salesforce.com", "id": "https://login.salesforce.com/id/00000000000/0000000000", "token_type": "Bearer", "issued_at": "1558553873237" } ``` The access token can be used to make calls to the Account Engagement API. The code was exchanged for the access token on the server side and not from the user’s browser. Because of how the code was exchanged, there’s no opportunity for malicious JavaScript to steal the access token. After you’ve implemented authorization, you can start working with the Account Engagement API. ## Working with the API With the Account Engagement API, your app can access current data within Account Engagement. Through the API, you can perform several common operations on Account Engagement objects including: - `create`: Creates an instance of the object with the specified parameters. - `read`: Retrieves information about the specified object. - `query`: Retrieves objects that match the specified criteria. - `update`: Updates elements of an existing object. - `upsert`: Updates elements of an existing object if it exists. If the object doesn’t exist, one is created using the supplied parameters. Developers must authenticate using a Salesforce OAuth endpoint or the Account Engagement API login endpoint before issuing Account Engagement API requests. Refer to the Authentication section for details about this procedure. Keep in mind a few considerations when you perform requests. For update requests, only the fields specified in the request are updated. All others are left unchanged. If a required field is cleared during an update, the request is declined. ### Request Format All requests to the API must: - Use either HTTP GET or POST. Version 5 also supports PUT and DELETE requests. - Pass the access token in an HTTP Authorization header. - Pass the Account Engagement Business Unit ID in an HTTP Pardot-Business-Unit-Id header. - Use the correct URL for your Account Engagement environment. ### Our First GET Request In this example, we want to get a list of all custom fields in a business unit. Before you begin, make sure you’ve authenticated and have a valid access token. For simplicity in this example, these calls are written in HTTP. ``` GET /api/customField/version/4/do/query?format=json HTTP/1.1 Host: pi.pardot.com Authorization: Bearer Pardot-Business-Unit-Id: ``` #### Breaking Down the Request Let’s break down the call and identify its parts, starting with the uniform resource identifier (URI). `GET https:///api//version//do/?format=` - **Environment URL**: In the example, we use pi.pardot.com, but you use the URL that matches your environment type. Demos, developer orgs, and sandbox environments are hosted on the domain pi.demo.pardot.com. Training and production environments are hosted on the domain pi.pardot.com. - **Object**: The object we’re requesting data for. In our example, we’re querying the CustomField object. - **API version**: The version of the API you’re using. Here, we use v4. - **Operation**: The operation you’re performing. Here, we use `query`. - **Format**: The output format, either XML or JSON. Here, we use `json`. Now that we’ve explained the URI, let’s examine the header lines in the call. - `Authorization: Bearer ` lets Account Engagement know that you’ve authenticated and have permission to access data. - `Pardot-Business-Unit-Id: ` lets Account Engagement know which business unit you want data from. - `Host`: The URL for your Account Engagement environment. #### Breaking Down the Response The call returns the business unit’s custom fields and their metadata. ```json { "@attributes": { "version": 1, "stat": "ok" }, "result": { "customField": [ { "id": 14141, "is_use_values": false, "crm_id": null, "is_record_multiple_responses": false, "field_id": "Attended_Event", "type_id": 1, "updated_at": "2020-08-04 05:45:36", "is_analytics_synced": false, "type": "Text", "created_at": "2020-08-04 05:45:36", "name": "Attended Event?" }, { "id": 14143, "is_use_values": false, "crm_id": null, "is_record_multiple_responses": false, "field_id": "Birthday", "type_id": 12, "is_analytics_synced": false, "updated_at": "2020-08-04 05:45:56", "created_at": "2020-08-04 05:45:56", "name": "Birthday", "type": "Date" } ], "total_results": 2 } } ``` Learn more about each object’s fields in the [Object Field Reference documentation](https://developer.salesforce.com/docs/marketing/pardot/guide/object-field-reference.md). ### Our First POST Request **warning:** If you’re following along with your Account Engagement instance, this next example creates a list in your account. Either use a sandbox account or customize the example to fit your needs. In this example, we create a list for a spring nurturing campaign. Before you begin, make sure you’ve authenticated and have a valid access token. ``` POST /api/list/version/4/do/create?format=json HTTP/1.1 Host: pi.pardot.com Content-Type: application/x-www-form-urlencoded Authorization: Bearer Pardot-Business-Unit-Id: name=Spring Leads Nurture&title=Spring Leads title&description=A list to nurture spring leads ``` #### Breaking Down the Request We went over the URI and the authorization and business unit headers in the GET example. Let’s cover the other components: - `Content-Type: application/x-www-form-urlencoded`: Tells the server what kind of data is included in the request. - `name=Spring Leads Nurture`: Sets the internal name of the list to "Spring Leads Nurture." - `title=Spring Leads`: Titles the list "Spring Leads." - `description=A list to nurture spring leads`: Adds a text description to the list. #### Breaking Down the Response When we send this request to the server, Account Engagement responds by creating a list with the criteria that we specified. The response looks like this: ```json { "@attributes": { "stat": "ok", "version": 1 }, "list": { "id": 1000, "name": "Spring Leads Nurture", "is_public": false, "is_dynamic": false, "title": "Spring Leads", "description": "A list to nurture spring leads ", "is_crm_visible": false, "created_at": "2021-02-12 08:09:10", "updated_at": "2021-02-12 08:09:10" } } ``` ### Going Further Let’s take the example a step further and add a prospect to our new list. Remember that completing this task changes data in Account Engagement, so proceed with caution. Before you begin, make sure you’ve authorized and have a valid access token. For simplicity in this example, we make these calls in our command-line interface using cURL. First, copy the list ID for the list you want to add a prospect to. Then, find the IDs for the prospect you want to add to the list. You can use `query` on the Prospect object to get ID. - List ID: 1000 - Prospect ID: XXXXX ``` POST /api/prospect/version/4/do/update/id/XXXXX?format=json HTTP/1.1 Host: pi.pardot.com Content-Type: application/x-www-form-urlencoded Authorization: Bearer Pardot-Business-Unit-Id: list_=1000 ``` Notice that the URI includes the prospect’s ID: XXXXX. When we send this request, Account Engagement adds that prospect to the list with the ID 1000. ## What’s Next It can be helpful to talk to other developers about the problems you’re working on. Connect with like-minded Account Engagement developers by joining a [Trailblazer Community Group](https://trailblazercommunitygroups.com/) near you. ## See Also - _Salesforce Help_: [External Client Apps](https://help.salesforce.com/s/articleView?id=xcloud.external_client_apps.htm) - _Salesforce Help_: [Authorize Apps with OAuth](https://help.salesforce.com/articleView?id=sf.remoteaccess_authenticate.htm) # Account Engagement Open-Source Labs Apps The following apps are provided as-is and are managed as open-source projects. These applications provide solutions to various customer pain points for marketers. Even better, the apps provide real-world examples that developers can leverage to start their own application. Here is an overview of the apps at your disposal. | Application Name | Customer Value | AppExchange Listing | GitHub Location | Example of | | --------------------------------------------------------------------- | ------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------- | | Embedded Feedback within Account Engagement Emails | Gather instant feedback from prospects within Account Engagement emails. | [Listing](https://appexchange.salesforce.com/listingDetail?listingId=a0N3u00000PGx6K) | [Repo](https://github.com/SalesforceLabs/Pardot-Embedded-Feedback) | Email builder custom component | | Account Engagement List Control For Salesforce | Easily manage your prospects without leaving your Salesforce record. | [Listing](https://appexchange.salesforce.com/listingDetail?listingId=a0N3u00000PGzZ4) | [Repo](https://github.com/SalesforceLabs/MJPardotContest) | Account Engagement API integration | | Newsletter Lightning Email Template with Google API custom components | Create a newsletter with components for YouTube, Webinars, and Google Calendar. | [Listing](https://appexchange.salesforce.com/listingDetail?listingId=a0N3u00000PH6eV) | [Repo](https://github.com/SalesforceLabs/GoogleAPIsIntegratedEmailTemplate) |
  • Packaged email template
  • Email builder custom component
| | Account Engagement Forms Everywhere! | Use your Account Engagement forms all over Salesforce. | [Listing](https://appexchange.salesforce.com/listingDetail?listingId=a0N3u00000PH6Zf) | [Repo](https://github.com/SalesforceLabs/PardotFormsEverywhere) |
  • Email builder custom component
  • Account Engagement API integration
| | Video for Email | Add video to your emails in a delightfully simple way. | [Listing](https://appexchange.salesforce.com/listingDetail?listingId=a0N3u00000PH4Io) | [Repo](https://github.com/SalesforceLabs/Video-Email) |
  • Email builder custom component
  • External API Integration
| | Email Validator for Account Engagement | Keep your prospect database clean and improve email deliverability. | [Listing](https://appexchange.salesforce.com/ListingDetail?listingId=a0N3u00000RNEwI) | [Repo](https://github.com/SalesforceLabs/EmailValidator) |
  • External Actions (Apex)
  • API V5
  • API Authentication
| Love these ideas and want to make them your own? Check out our [Account Engagement ISV Getting Started](https://developer.salesforce.com/docs/marketing/pardot/guide/isv-getting-started.html). # Additional Resources Use these resources to get the most out of the Account Engagement API. ## Trailhead - [Marketing Cloud Account Engagement API: Quick Look](https://trailhead.salesforce.com/content/learn/modules/pardot-api-quick-look): Learn how APIs can extend and automate Account Engagement for your business. - [Marketing Cloud Account Engagement Basics](https://trailhead.salesforce.com/content/learn/modules/pardot-basics-lightning): Learn what Account Engagement is and how it can help you market to other businesses. ## Postman Account Engagement has a public Postman collection for v5 of the API. Postman simplifies making calls and experimenting with the API. Learn more, and install the collection from [GitHub](https://github.com/pardot/postman-pardot-apis). If you're not familiar with Postman, check out the [Postman API Client](https://trailhead.salesforce.com/content/learn/modules/postman-api-client) module on Trailhead. ## Help Content Use [Salesforce Help](https://help.salesforce.com/s/articleView?id=sf.bundle_pardot_parent.htm&type=5) to discover more about Account Engagement features and capabilities. # API V5 for Flow Development Guide ## Introduction With API V5 for Flow, admins can manage their content and customize their management processes in powerful, new ways. Use API V5 Flow for these actions. 1. Import Content Templates 2. Connect external content builders to Account Engagement 3. Copy content and assets between business units 4. Copy assets from Sandbox to Production orgs and vice versa ## Basics of Salesforce Flow Build custom user interfaces, create custom tasks, and schedule automated workflows by using Salesforce Flow. This guide focuses on-screen flow use cases. To learn about other Salesforce Flow use cases, and to learn more about flow in general, refer to these Trailheads. 1. [Flow Trail](https://trailhead.salesforce.com/content/learn/trails/build-flows-with-flow-builder) 2. [Schedule-Triggered Flows](https://help.salesforce.com/apex/HTViewHelpDoc?id=sf.flow_considerations_trigger_schedule.htm&language=en_US) 3. [Flow Types](https://help.salesforce.com/s/articleView?id=sf.flow_concepts_type.htm&language=en_US&r=https%3A%2F%2Fwww.google.com%2F&type=5) This guide assumes you have a baseline understanding of Salesforce Flow. Flow will seem familiar to users of Engagement Studio, in that it also includes: 1. A Visual Builder Interface using a Canvas 2. Top-to-Bottom Workflow using Steps 3. Salesforce Object Triggers (Flow doesn’t have the concept of triggers within a flow) 4. Three basic concepts for screen flows: - Screens - Used to Interact with User and Gather Input - Actions - Used to Retrieve Data or Execute an Action - Conditions - Used to create criteria to determine a path Because it’s designed for general processes, Flow is more advanced than Engagement Studio. Note these capabilities. 1. Define objects 2. Add custom actions 3. Perform loops 4. Package Flows ## API V5 Flow Actions API V5 is integrated into Flow using Apex Invocable Actions, which expose the Account Engagement API to Flow. With Flow, you can perform these general functions. 1. Generate Picklists - Use: A user can search for and select a record. - Input: - Object Name - Business Unit ID - Output - JSON String of Content Name, Content Record IDs 2. Create an Asset - Use: Creates a content record. - Action Naming Schema: Create X Record - Input: - Asset ID 3. Read an Asset - Use: Retrieve all the data for an asset. - Action Naming Schema: Read X Record - Input: - Asset ID - Output: - Content Record To store the results of the Read and Create actions, each supported object needs an associated Apex Defined Object Class to represent the data in the object. ## Getting Started Checklist - Access to Salesforce org with Marketing Cloud Account Engagement - User Access to build and run Flows - User Access to relevant business units - Install the latest Marketing Cloud Account Engagement Managed Package ## API V5 for Flow Actions ### Bulk Action Endpoints **Get My Business Unit**
Retrieves the list of business units relevant to a given user. | API Object | Inputs | Outputs | Additional Details | | -------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | -------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------- | | [Business Unit Context](https://developer.salesforce.com/docs/atlas.en-us.238.0.chatterapi.meta/chatterapi/connect_resources_pardot_business_unit_context.htm) | **From Sandbox (Boolean)**
Choose to query for Business Units from the Sandbox (applicable for Sandbox-Production Bulk Asset Copy Flow).Overrides the Folder

**Named Credential (String)**
Use for Salesforce Metadata API Access. | **Picklist Output (Object List)**
A list of business units names and IDs.Overrides the Folder | The results only include the business units that the active user of the flow has access to. | **Generate Flow Context**
Combine all the variables, and then generate a context that can be used as an input for all the invocable actions. | Inputs | Outputs | Additional Details | | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------- | | **Interview Guide (String)**
The value of $Flow.InterviewGuide.Overrides the Folder

**Named Credential to Use for Account Engagement API Access (String - Optional)**
API name to access cross-org Account Engagement API.Overrides the Folder

**Production Business Unit ID (String - Optional)**

**Sandbox Business Unit ID (String - Optional)**

**Copy from Production to Sandbox (Boolean - Optional)**
True when copying from Sandbox to Production org. The default value is null. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Flow Context (FlowContextModel)**
The generated Flow Context. | All the fields except the Interview Guide are only applicable when copying assets from Sandbox to Production orgs and vice versa. | **Get Dropdown Options**
Retrieves a list of options for the given object and business unit. | API Object | Inputs | Outputs | Additional Details | | ---------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | Multiple | **Business Unit ID (String)**
The ID of the business unit to access.

**Query Object (String)**
The V5 API name of the object that you want to retrieve dropdown options.

**Field Parameters (String - Optional)**
The fields to use for the name and value for the dropdown. The default is “id, name” and, for most objects, doesn’t require a change.

**Flow Context (FlowContextModel)**
Context generated using Generate Flow Context invocable action. | **Picklist Output (PickListOutput[])**
The names and values of the returned object records | The action uses the API V5 query API, so it follows any query data restrictions that exist for that object. For example, the HTML field for email templates can’t be returned in a query.

**Objects Supported:**
  • email-templates
  • custom-fields
  • custom-redirects
  • files
  • folders
  • campaigns
  • tracker-domains
  • engagement-studio-programs
  • forms
  • form-handlers
  • dynamic-content
  • landing-pages
  • layout-templates
| **Get Email Template**
Retrieves the details of an Email Template. | API Object | Inputs | Outputs | | ----------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Email Template](https://developer.salesforce.com/docs/marketing/pardot/guide/email-template-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Email Template (Object)**
An Email Template object record. Able to pass the object returned in the Get Email Template action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Email Template (Object)**
The Email Template represented by the input ID. | **Copy Email Template**
Creates an Email Template by using the provided inputs. | API Object | Inputs | Outputs | | ----------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Email Template](https://developer.salesforce.com/docs/marketing/pardot/guide/email-template-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Campaign ID (String - Optional)**
Overrides the Campaign to use when creating the Email Template.

**Folder ID (String - Optional)**
Overrides the Folder to use when creating the email template.

**Tracker Domain ID (String - Optional)**
Overrides the tracker domain to use when creating the email template.

**Email Template (Object)**
An email template object record. Able to pass the object returned in the Get Email Template action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Email Template (Object)**
The newly created Email Template. | **Get Custom Redirect**
Retrieves the details of a Custom Redirect. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Custom Redirect](https://developer.salesforce.com/docs/marketing/pardot/guide/custom-redirect-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Custom Redirect (String)**
The ID of the Custom Redirect that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Custom Redirect (Object)**
The Custom Redirect represented by the input ID. | **Copy Custom Redirect**
Creates a Custom Redirect by using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Custom Redirect](https://developer.salesforce.com/docs/marketing/pardot/guide/custom-redirect-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Campaign ID (String)**
Overrides the Campaign to use when creating the Custom Redirect.

**Folder ID (String)**
Overrides the Folder used to use when creating the Custom Redirect.

**Tracker Domain ID (String)**
Overrides the Tracker Domain to use when creating the Custom Redirect.

**Custom Redirect (CustomRedirectModel)**
A Custom Redirect object record. Can pass the object returned in the Get Custom Redirect action as an input.

**Flow Context (FlowContextModel)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Custom Redirect (Object)**
The newly created Custom Redirect. | **Get Custom Field**
Retrieves the details of a Custom Field. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Custom Field](https://developer.salesforce.com/docs/marketing/pardot/guide/custom-field-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Custom Field ID (String)**
The ID of the Custom Field that you want to retrieve.

**Flow Context (FlowContextModel)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Custom Field (CustomFieldModel)**
The Custom Field represented by the input ID. | **Copy Custom Field**
Creates a Custom Field using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Custom Redirect](https://developer.salesforce.com/docs/marketing/pardot/guide/custom-redirect-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Campaign ID (String)**
Overrides the Campaign to use when creating the Custom Redirect.

**Folder ID (String)**
Overrides the Folder used to use when creating the Custom Redirect.

**Tracker Domain ID (String)**
Overrides the Tracker Domain to use when creating the Custom Redirect.

**Custom Redirect (CustomRedirectModel)**
A Custom Redirect object record. Can pass the object returned in the Get Custom Redirect action as an input.

**Flow Context (FlowContextModel)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Custom Redirect (Object)**
The newly created Custom Field. | **Get Dynamic Content**
Retrieves the details of Dynamic Content. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Dynamic Content](https://developer.salesforce.com/docs/marketing/pardot/guide/dynamic-content-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Custom Dynamic Content ID (String)**
The ID of the Dynamic Content that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Dynamic Content(DynamicContentModel)**
The Dynamic Content represented by the input ID. | **Copy Dynamic Content**
Creates new Dynamic Content using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | [Dynamic Content](https://developer.salesforce.com/docs/marketing/pardot/guide/dynamic-content-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Folder ID (String)**
Overrides the Folder to use when creating the Dynamic Content.

>**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Dynamic Content (DynamicContentModel)**
The newly created Dynamic Content. | **Get Engagement Studio Program**
Retrieves the details of an Engagement Studio Program. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Engagement Studio Program](https://developer.salesforce.com/docs/marketing/pardot/guide/engagement-studio-program-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Engagement Studio Program ID (String)**
The ID of the Engagement Studio Program that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Engagement Studio Program (EngagementStudioProgramModel)**
The Engagement Studio Program represented by the input ID. | **Copy Engagement Studio Program**
Creates an Engagement Studio Program using the provided inputs. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Engagement Studio Program](https://developer.salesforce.com/docs/marketing/pardot/guide/engagement-studio-program-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Destination Business Unit ID (String)**
The ID of the business unit to access.

**Folder ID (String)**
Overrides the Folder to use when creating the Engagement Studio Program.

**Engagement Studio Program (EngagementStudioProgramModel)**
An Engagement Studio Program object record. Can pass the object returned in the Get Engagement Studio Program action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Engagement Studio Program (EngagementStudioProgramModel)**
The newly created Engagement Studio Program. | **Get File**
Retrieves the details of a File. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | [File](https://developer.salesforce.com/docs/marketing/pardot/guide/file-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**File ID (String)**
The ID of the File that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**File (FileModel)**
The File represented by the input ID. | **Copy File**
Creates a File using the provided inputs. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [File](https://developer.salesforce.com/docs/marketing/pardot/guide/file-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**File ID (String)**
**Campaign ID (String - Optional)**
Overrides the Campaign to use when creating the file.

**Folder Id (String)**
Overrides the Folder to use when creating the File.

**Tracker Domain ID (String)**
Overrides the tracker domain to use when creating the File.

**File (FileModel)**
A File object record. Can pass the object returned in the Get File action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**File (FileModel)**
The newly created File. | **Get Form**
Retrieves the details of a Form. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | [Form](https://developer.salesforce.com/docs/marketing/pardot/guide/form-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Form ID (String)**
The ID of the Form that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Form (FormModel)**
The Form represented by the input ID. | **Copy Form**
Creates a Form by using the provided inputs. | API Object | Inputs | Outputs | | --------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Form](https://developer.salesforce.com/docs/marketing/pardot/guide/form-v5.html) | **Source Business Unit ID (String)**
The ID of the business unit to access.

**Destination Business Unit ID**
The ID of the business unit to access.

**Campaign ID (String)**
Overrides the Campaign to use when creating the Form.

**Folder ID (String)**
Overrides the Folder to use when creating the Form.

**Tracker Domain ID (String)**
Overrides the tracker domain to use when creating the Form.

**Layout Template ID (String)**
Overrides layout template to use when creating the Form.

**Form (FormModel)**
A Form object record. Can pass the object returned in the Get Form action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Form (FormModel)**
The newly created Form. | **Get Form Handler**
Retrieves the details of a Form Handler. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Form Handler](https://developer.salesforce.com/docs/marketing/pardot/guide/form-handler-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Form Handler ID (String)**
The ID of the Form Handler that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Form Handler (FormHandlerModel)**
The Form Handler represented by the input ID. | **Copy Form Handler**
Creates a Form Handler using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Form Handler](https://developer.salesforce.com/docs/marketing/pardot/guide/form-handler-v5.html) | **Source Business Unit ID (String)**
The ID of the business unit to access.

**Destination Business Unit ID**
The ID of the business unit to access.

**Campaign ID (String)**
Overrides the Campaign to use when creating the Form.

**Folder ID (String)**
Overrides the Folder to use when creating the Form.

**Tracker Domain ID (String)**
Overrides the tracker domain to use when creating the Form Handler.

**Form Handler (FormHandlerModel)**
A Form Handler object record. Can pass the object returned in the Get Form Handler action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Form Handler (FormHandlerModel)**
The newly created Form Handler. | **Get Layout Template**
Retrieves the details of a Layout Template. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Layout Template](https://developer.salesforce.com/docs/marketing/pardot/guide/layout-template-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Layout Template ID (String)**
The ID of the Layout Template that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Layout Template (LayoutTemplateModel)**
The Layout Template represented by the input ID. | **Copy Layout Template**
Creates a Layout Template using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | [Layout Template](https://developer.salesforce.com/docs/marketing/pardot/guide/layout-template-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Folder ID (String)**
Overrides the Folder to use when creating the Layout Template.

**Layout Template ID (String)**
Overrides the layout template object record. Can pass the object returned in the Get Layout Template action as an input.

**Layout Template (LayoutTemplateModel)**
A Layout Template object record. Can pass the object returned in the Get Layout Template action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Layout Template (LayoutTemplateModel)**
The newly created Layout Template. | **Get Landing Page**
Retrieves the details of a Landing Page. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Landing Page](https://developer.salesforce.com/docs/marketing/pardot/guide/landing-page-v5.html) | **Business Unit ID (String)**
The ID of the business unit to access.

**Landing Page ID (String)**
The ID of the Landing Page that you want to retrieve.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Landing Page (LandingPageModel)**
The Landing Page represented by the input ID. | **Copy Landing Page**
Creates a Landing Page using the provided inputs. | API Object | Inputs | Outputs | | ------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Landing Page](https://developer.salesforce.com/docs/marketing/pardot/guide/landing-page-v5.html) | **Source Business Unit ID (String)**
The ID of the business unit to access.

**Destination Business Unit ID**
The ID of the business unit to access.

**Campaign ID (String - Optional)**
Overrides the Campaign to use when creating the Landing Page.

**Folder ID (String)**
Overrides the Folder to use when creating the Landing Page.

**Folder ID (String)**
Overrides the Folder to use when creating the Landing Page.

**Tracker Domain ID (String - Optional)**
Overrides the tracker domain to use when creating the Landing Page.

**Landing Page (LandingPageModel)**
A Landing Page object record. Can pass the object returned in the Get Landing Page action as an input.

**Flow Context (FlowContextModel - Optional)**
Flow context generated using Generate Flow Context invocable action. | **Message (String)**
An action success or failure message.

**Is Success? (Boolean)**
An action success or failure indicator.

**Landing Page (LandingPageModel)**
The newly created Landing Page. | ## API V5 for Flow Lightning Web Components | LWC | Purpose | Input | Output | | ----------------- | --------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | combobox | Type ahead search with multi-select/single-select option. | `label: String:`

`required: Boolean`
`multiSelect: Boolean`
whether the combobox is multi-select or not

`messageWhenInvalid: String`
Displays the given error with this message if necessary is true and the user doesn’t select the value.

`options: PicklistOutput[]` | `selectedValue: String`
Returns selected value for single-select combobox.
`selectedValues: String[]`
Returns a list of selected values for a multi-select combobox.
| | previewAssets | Preview the asset in a tabular format with given data. | `emailTemplates: EmailTemplateModel[]`

`customRedirects: CustomRedirectModel[]`
`files: FileModel[]`
`customFields: CustomFieldModel[]`
`engagementStudioPrograms: EngagementStudioProgramModel[]]`
`layoutTemplates: LayoutTemplateModel[]`
`formHandlers: FormHandlerModel[]`
`dynamicContent: DynamicContentModel[]`
`forms: FormModel[]`
`landingPages: LandingPageModel[]` | Displays the assets on the flow `screen`. | | progressIndicator | Displays progress based on provided current step. | `currentStep: Integer` | Displays the progress indicator (steps) on the flow screen. | ## API V5 for Flow Apex Defined Objects These sections detail the unique objects provided in the API V5 for Flow toolkit. ### Picklist Output The following is a general class to store picklist values for Account Engagement objects. A picklist output includes a display value that shows the user, and a reference ID to retrieve the record the user selects. ```apex PicklistOutput { String id; String name; String domain; // to support tracker-domain picklist } ``` ### Email Template The Email Template model represents an Account Engagement Email Template. ```apex EmailTemplateModel { Integer id; String name; String subject; String htmlMessage; String textMessage; Boolean isOneToOneEmail; Boolean isAutoResponderEmail; Boolean isDripEmail; Boolean isListEmail; List senderOptions; Integer trackerDomainId; Integer folderId; String type; Integer campaignId; SenderOption { String type; String address; String name; } ``` ### Custom Redirect The custom redirect model represents an Account Engagement Custom Redirect. ```apex CustomRedirectModel { Integer id; String name; String destinationUrl; Integer folderId; Integer campaignId; Integer trackerDomainId; String vanityUrlPath; String gaCampaign; String gaContent; String gaMedium; String gaSource; String gaTerm; } ``` ### Custom Field The Custom Field model represents an Account Engagement Custom Field. ```apex CustomFieldModel { String fieldId; Integer id; Boolean isRecordMultipleResponses; Boolean isRequired; Boolean isUseValues; String name; String salesforceId; String type; String statusText; String errorMessage; } ``` ### File The File model represents an Account Engagement File. ```apex FileModel { Integer id; String name; Integer folderId; Integer campaignId; Integer trackerDomainId; String url; String statusText; String errorMessage; } ``` ### Engagement Studio Program The Engagement Studio Program model represents an Account Engagement Studio Program. ```apex EngagementStudioProgramModel { Integer id; String name; Integer folderId; String statusText; String errorMessage; } ``` ### Form The Form model represents an Account Engagement Form. ```apex FormModel { Integer id; String name; Integer campaignId; Integer folderId; Integer trackerDomainId; Integer layoutTemplateId; String submitButtonText; String redirectLocation; String thankYouContent; String thankYouCode; String beforeFormContent; String afterFormContent; String fontSize; String fontFamily; String fontColor; String labelAlignment; String radioAlignment; String checkboxAlignment; String requiredCharacter; Boolean showNotProspect; Boolean isAlwaysDisplay; Boolean isCaptchaEnabled; Boolean isCookieless; String statusText; String errorMessage; } ``` ### Form Handler The Form Handler model represents an Account Engagement Form Handler. ```apex FormHandlerModel { Integer id; String name; Integer folderId; Integer campaignId; Integer trackerDomainId; Boolean isDataForwarded; String successLocation; String errorLocation; Boolean isAlwaysEmail; Boolean isCookieless; String statusText; String errorMessage; } ``` ### Dynamic Content The Dynamic Content model represents an Account Engagement Dynamic Content. ```apex DynamicContentModel { String name; Integer id; String baseContent; String basedOnProspectApiFieldId; Integer folderId; Integer trackerDomainId; List variations; String statusText; String errorMessage; } ``` ### Landing Page The Landing Page model represents an Account Engagement Landing Page. ```apex LandingPageModel { Integer id; String name; Integer campaignId; Integer formId; Integer layoutTemplateId; String title; String description; Boolean isDoNotIndex; String vanityUrlPath; String scriptFragment; String redirectLocation; Integer trackerDomainId; Integer folderId; String archiveDate; String content; String openingGeneralContent; String statusText; String errorMessage; } ``` ### Layout Template The Layout Template model represents an Account Engagement Layout Template. ```apex LayoutTemplateModel { Integer id; String name; String layoutContent; String formContent; Boolean isIncludeDefaultCss; Integer folderId; String statusText; String errorMessage; } ``` ### Flow Context The Flow Context model represents a GenerateFlowContext invocable action. ```apex FlowContextModel { Boolean isDefaultFlow = false; String accountEngagementSandboxBUCredential; String productionBusinessUnitId; String sandboxBusinessUnitId; Boolean productionToSandbox; } ``` ## Cross-Business-Unit Asset Copy Flow Walkthrough You can find the provided flow, **Account Engagement Bulk Asset Copy**, from **Setup** →**Flow**. This default flow provides a moderately complex example of how a copy flow is built. The flow just repeats the same basic pattern on multiple assets. The steps are: - Determine the Business Unit that contains the assets you want to copy, and the Business Unit that you want to copy those assets into - Select the assets to copy - Read the assets to copy - Configure the assets for copying - Create the copied assets To start, pull the available Business Units and select the source and destination. ![Select business units after the flow start step](https://developer.salesforce.com/docs/media/mcae_api_flow1.png) Next, pull the picklist values used for the rest of the flow. ![Add assets to the flow](https://developer.salesforce.com/docs/media/mcae_api_flow2.png) These queries are made to prepare for selecting and configuring the assets to copy. - Configuration - Campaigns - Folders - Tracker Domains - Assets - Email Templates - Custom Fields - Custom Redirects - Files - Engagement Studio Programs Select the assets to copy and validate to ensure a copy can occur. ![Select assets to copy screen in flow](https://developer.salesforce.com/docs/media/mcae_api_flow3.png) A screen presents a dropdown for each asset using a multi-select picklist, allowing for multiple options per dropdown. If any assets are selected, the process continues to read the assets. The following loops, repeated for each asset, pull the asset data from the source business unit. ![Flow loop](https://developer.salesforce.com/docs/media/mcae_api_flow4.png) The loop goes through each asset selected and reads its record from the source business unit, adding it to a new collection. The loop repeats for each asset so that all the data for copying is available for later steps. After all the information is read, summary information is presented to confirm the correct files are copied. From here, configure the campaign, folder, and tracker domain to use in the destination business unit. ![Configure campaign and folder in Flow](https://developer.salesforce.com/docs/media/mcae_api_flow5.png) The second set of loops go through each copy request and creates the record in the destination business unit. ![Copy assets in Flow](https://developer.salesforce.com/docs/media/mcae_api_flow6.png) The loop cycles through the selected asset records, using the field settings as input to the copy action. The final step records the new records ID and provides success confirmation. ![Confirm copy in Flow](https://developer.salesforce.com/docs/media/mcae_api_flow7.png) The same patterns apply for custom flows, only with a different set of loops to build a different bulk copy flow. With custom flows, you can also remove the loop to create copies one at a time. ## General Use Cases Note: We recommend an understanding of the standard flow before attempting a custom flow. ### Cross-Business-Unit Asset Copy Create a custom copy flow to move the right assets between business units. The standard process for a copy is to select the assets to copy, read the assets, and then create the assets using the read data. ### Integrate an External Builder Select an asset in an external location and copy it into Account Engagement. Note: This use case requires an invocable action be built for the external builder service to retrieve the desired content. After the content is received, the remainder of the flow is the same. 1. Configure the asset. 2. Create the asset. ### Embed an Asset into Another Asset Select an asset URL to embed into another piece of content. This use case is more advanced and requires development to parse and embed the desired content. However, it’s possible to read the URL for forms, files, and custom redirects to embed them into HTML. ## Package a Flow Flows built with API V5 for Flow can be packaged, so you can share them via AppExchange or make it easy to install into production. The process of packaging a flow is the same as other packages. Under Salesforce Setup, go to Package Manager, and follow these steps. 1. Create a package 2. Add components to the package 3. Select the type Flow Definition. 4. Select your desired Flow Definition. 5. Upload the package 6. Install via the provided URL # Authentication Prerequisites: 1. You must have [Salesforce OAuth set up](https://developer.salesforce.com/docs/atlas.en-us.api_rest.meta/api_rest/intro_oauth_and_connected_apps.htm) in the org. To set up a connected app for OAuth, the "pardot_api" scope must be one of the selected OAuth scopes. Otherwise, OAuth flows other than username/password flow can't be used with the Account Engagement API. Check out this video for an example of how to implement OAuth. ::video{src="https://developer.salesforce.com/docs/marketing/pardot/guide/Bd9bUbJ8x1SezACaqnpPFB" title="Implement Salesforce OAuth for Account Engagement API" type="vidyard"} 1. You must have the Account Engagement Business Unit ID that you want to authenticate with. To find the Account Engagement Business Unit ID, use Setup in Salesforce. From Setup, enter "Business Unit Setup" in the Quick Find box. Your Account Engagement Business Unit ID begins with "0Uv" and is 18 characters long. If you can’t access the Business Unit Setup information, ask your Salesforce Administrator to provide you with the Account Engagement Business Unit ID. 2. Authenticate with a user that is SSO enabled. An SSO-enabled user is one who can log in to pi.pardot.com using "Log In with Salesforce" or who can access Account Engagement using the Account Engagement Lightning App. ## Oauth Authentication Domain by Account Type | **Account Type** | **Salesforce Domain** | **Account Engagement Domain** | | -------------------------------- | ---------------------- | ----------------------------- | | Production Account | `login.salesforce.com` | `pi.pardot.com` | | Account Engagement Developer Org | `login.salesforce.com` | `pi.demo.pardot.com` | | Sandbox | `test.salesforce.com` | `pi.demo.pardot.com` | ### OAuth 2.0 Flows There are numerous OAuth 2.0 Flow types supported. The [Web Server Flow](https://help.salesforce.com/s/articleView?id=sf.remoteaccess_oauth_web_server_flow.htm&type=5) is the most commonly used. For a list of all flows, see the [OAuth 2.0 Flows](https://help.salesforce.com/s/articleView?id=sf.remoteaccess_oauth_flows.htm&type=5) Help page. Read the descriptions of the flows to choose the best one for your case. ## Using Access Token with Account Engagement After you get the access token, you must pass it and the Account Engagement Business Unit ID using the `Authorization` and `Pardot-Business-Unit-Id` headers. ### Sample Request Request must be made using HTTPS. ```bash POST /api//version//do/ HTTP/1.1 Host: pi.pardot.com Authorization: Bearer Pardot-Business-Unit-Id: ``` ### Request Parameters | **Parameter** | **Required** | **Description** | | ------------------ | ------------ | ---------------------------------------------------- | | `access_token` | X | Access token obtained from Salesforce OAuth Endpoint | | `business_unit_id` | X | Account Engagement Business Unit ID | If a valid access token is provided with a valid business unit ID, the Account Engagement endpoint works as expected. Note: The Account Engagement API doesn’t enforce IP address restrictions that are configured using the Salesforce option "Enforce login IP ranges on every request". # Bulk Data Pull via the Account Engagement API This document outlines the approach and best practices for pulling large amounts of data out of Account Engagement via the API. ## Visitor Activity with Export API When you need large amounts of visitor activity data, use the Export API. If you need a different object, see [Query the Account Engagement API](#query-the-account-engagement-api) for details on how to retrieve the information using the query endpoint. The Export API is asynchronous and efficiently scales data retrieval based on the available resources. There are more server resources available for the Export API than the query endpoint, which provides faster results without hitting concurrency and API limits to process multiple queries. Before getting started, review the documentation for the Export API. ### Best Practice #1 - Polling for Status Updates Because export is asynchronous, you can poll the Read endpoint of the Export API to see if the export is done processing. The time an export takes depends on how much data is being exported and the resources available for processing. Because export times can vary, we recommend that you start by setting a polling interval between 30 seconds and a few minutes. If you run an integration regularly, set your polling intervals to the average of the time taken for a few runs of your integration. For example, if your integration runs daily and retrieves all visitor activity data for the previous day, start with a polling frequency of 1 minute. Note the export durations for a few days, then average those times to find a polling interval. In the example, over a few days you notice that your export finishes with an average duration of 15 minutes. Polling every minute is too often and polls 15 times. If you set the polling interval to 5 minutes, it polls three or four times. If you run integrations sporadically or infrequently, try increasing the polling interval over time. For example, if you track the number of times the integration has polled, you can calculate a gradually increasing polling interval using this function: ```bash ceil(((n * n)/5)+1) ``` Where `n` is the index of the poll, starting with 0 Using this function to calculate polling interval, you poll a minute the first time, 2 minutes for the second and continue to increase at larger intervals each time. This process allows the integration to check frequently soon after an export is created to catch the quick running exports but also limit the number of polls for exports that are long-running. Remember that the Read endpoint of the Export API counts toward API limits, so these tips let you adjust how much of that limit is used by your integration. ### Best Practice #2 - Specify Limited Date Ranges Because the results of the export API are returned only after the query has executed, limiting the date range of the export returns results faster. A way limit date range is to break large date ranges into several smaller ranges. For example, it's OK to create an export to retrieve a year's worth of visitor activity within a single export by specifying a year duration, like the following. ```powershell curl https://pi.pardot.com/api/export/version/3/do/create?format=json \ --H Authorization: Bearer \ --H Pardot-Business-Unit-Id: -d '{ "object": "visitorActivity", "procedure": { "name": "filter_by_created_at", "arguments": { "created_after": "2019-12-25 00:00:00", "created_before": "2020-12-25 00:00:00" } } }' ``` The issue is that all 12 months of data must be queried in order for the results to be returned. There are cases where your integration can use a smaller data set up front and be refined later as more data from the export becomes available. For example, an integration can work off the last month of data while waiting on a three-month range and then increasing to a twelve-month range. In this example, you could create three different exports with the three different ranges: Last month ```json "created_after": "2020-11-25 00:00:00", "created_before": "2020-12-25 00:00:00" ``` Three months prior ```json "created_after": "2020-08-25 00:00:00", "created_before": "2020-11-25 00:00:00" ``` Eight months prior ```json "created_after": "2019-12-25 00:00:00", "created_before": "2020-08-25 00:00:00" ``` Instead of waiting for all twelve months of data to be exported at once, the same data is returned in smaller increments, so you can see the newest data sooner. ## Query the Account Engagement API Pulling data from a query endpoint in the Account Engagement API is a straightforward, two-step process. First, log in with your Account Engagement user email, password, and user key to acquire an API key. Then, use the query endpoint for each data set to pull the data. Before getting started, review the object documentation and determine which data set you are going to pull. For a data set to be eligible for a bulk data pull, it must have a query operation that supports at least one of the following three sets of search filter criteria parameters: - `created_before` and `created_after` - `updated_before` and `updated_after` - `id_greater_than` and `id_less_than` Issue an HTTP GET to the appropriate query endpoint to pull the data back. The query response contains up to 200 rows from the data set you have requested. ### Best Practice #1 ‐ Use the Bulk Output Format For bulk data pulls, we strongly recommended that you use the `bulk` output format, which is highly optimized for performance. The `bulk` output format disables functionality that displays additional data in the API response such as nested object relationships (for example, campaign name for activities). Additionally, the bulk output format omits information about the total number of rows that matched your query, which enables the API to return a response more quickly. ### Best Practice #2 ‐ Avoid Offset For bulk data pulls, we strongly discourage use of the `offset` parameter. Instead, iterate through the data set using one of the supported search filter criteria parameters. As you process the query results in your code, store a high water mark value like the largest `id` or most recent `created_at` or `updated_at` value. Then, on your next query, send that high water mark value as the `id_greater_than`, `created_after`, or `updated_after` search filter parameter value. ### Bulk API Request & Response Samples Example Request & Response (XML) ```bash curl https://pi.pardot.com/api/visitorActivity/version/3/do/query?output=bulk \ --header Authorization: Bearer \ --header Pardot-Business-Unit-Id: ``` ```xml 1000 6789 100 1 Email Tracker
http://www.pardot.com/products/demos/flash-demo.html
555 1 2021-08-09 19:29:07
1001 6789 100 1 Email Tracker
http://www.pardot.com/products/demos/flash-demo.html
555 1 2021-08-09 20:13:40
``` Example Request & Response (JSON) ```bash curl https://pi.pardot.com/api/visitorActivity/version/3/do/query?output=bulk&format=json \ --header Authorization: Bearer \ --header Pardot-Business-Unit-Id: ``` ```json { "@attributes": { "stat": "ok", "version": 1 }, "result": { "visitor_activity": [ { "id": 1000, "visitor_id": 5678, "prospect_id": 100, "type": 1, "type_name": "Email Tracker", "details": "http://www.pardot.com/products/demos/flash-demo.html", "email_id": 555, "campaign_id": 1, "created_at": "2021-08-09 19:29:07" }, { "id": 1001, "visitor_id": 5678, "prospect_id": 100, "type": 1, "type_name": "Email Tracker", "details": "http://www.Account Engagement.com/products/demos/flash-demo.html", "email_id": 555, "campaign_id": 1, "created_at": "2021-08-09 20:13:40" } ] } } ``` ## Example of Paging through a Large Set of Results Because using the offset parameter is discouraged, let’s see how you can use a high water mark value to iterate through multiple pages of results instead. In this example, you query for all visitor activities that occurred yesterday. The `created_after` and `created_before` search filter criteria parameters are perfect for this use case. To keep things simple, assume there were a total of 5 activities created yesterday (at time of writing, 2016-03-29) at times 02:00, 06:00, 10:00, 14:00, and 18:00. Also assume the API page size limit is 2 rather than 200. To iterate over the results in the suggested approach, your API integration process would proceed as follows: 1. Log in to the Account Engagement API 2. Pull all visitor activity created after yesterday at midnight (`2016-03-29T00:00:00`) and before tonight at midnight (`2016-03-30T00:00:00`): Example Request & Response (JSON) ```bash curl https://pi.pardot.com/api/visitorActivity/version/3/do/query?output=bulk&format=json&created_after=2016-03-29T00:00:00&created_before=2016-03-30T00:00:00&sort_by=created_at&sort_order=ascending \ --header Authorization: Bearer \ --header Pardot-Business-Unit-Id: ``` ```json { "@attributes": { "stat": "ok", "version": 1 }, "result": { "visitor_activity": [ { "id": 1000, "created_at": "2016-03-29 02:00:00" }, { "id": 1001, "created_at": "2016-03-29 06:00:00" } ] } } ``` _Note_: The example was edited for brevity. 1. The API has returned two results - the activities from 02:00 and 06:00. Since you are paging by `created_at`, set your high water mark value to the `created_at` value of the last record you pull back, `2016-03-30T06:00:00`. You have now retrieved all activities up to that time. 2. Pull all visitor activity created after your high water mark (`2016-03-29T06:00:00`) and before tonight at midnight (`2016-03-30T00:00:00`): Example Request & Response (JSON) ```bash curl https://pi.pardot.com/api/visitorActivity/version/3/do/query?output=bulk&format=json&created_after=2016-03-29T06:00:00&created_before=2016-03-30T00:00:00&sort_by=created_at&sort_order=ascending \ --H Authorization: Bearer \ --H Pardot-Business-Unit-Id: ``` ```json { "@attributes": { "stat": "ok", "version": 1 }, "result": { "visitor_activity": [ { "id": 1000, "created_at": "2016-03-29 10:00:00" }, { "id": 1002, "created_at": "2016-03-29 14:00:00" } ] } } ``` _Note_: The example was edited for brevity. 5. The API returns two more results back - the activities from 10:00 and 14:00. Since you are paging by `created_at`, update your high water mark value to the `created_at` value of the last record you pull back, `2021-03-29T14:00:00`. You have now retrieved all activities up to that time. 6. Pull all visitor activity created after your high water mark (`2021-03-29T14:00:00`) and before tonight at midnight (`2021-03-30T00:00:00`): Example Request & Response (JSON) ```bash curl https://pi.pardot.com/api/visitorActivity/version/3/do/query?output=bulk&format=json&created_after=2021-03-29T14:00:00&created_before=2021-03-30T00:00:00&sort_by=created_at&sort_order=ascending \ --header Authorization: Bearer \ --header Pardot-Business-Unit-Id: ``` ```json { "@attributes": { "stat": "ok", "version": 1 }, "result": { "visitor_activity": [ { "id": 1001, "created_at": "2021-03-29 18:00:00" } ] } } ``` _Note_: The example was edited for brevity. 1. The API returns one result back, the activity from 18:00. As the max page size is 2 and the API returned one record, you know you are at the end of the list of records and do not need to query any further. If the API had returned 2 records you would repeat the query process again with a new high water mark. You know it’s safe to stop when the number of records returned by the API is less than the max page size. # Error Codes and Messages Use your error code or message to troubleshoot problems with the API. **tip:** Use CTRL+F to search this page for the error code or message you received. ## Error Responses in API Versions 3 and 4 In versions 3 and 4, errors are formatted as follows: ```xml error_message ``` ```json { "@attributes": { "stat": "fail", "version": , "err_code": "" }, "err": "Invalid action" } ``` ## Error Responses in API Version 5 In version 5, errors are formatted as follows: ```xml { "code": , "message": } ``` ## Numerical List of Error Codes ### Error Code: `1` **Message**: Invalid API key or user key **Problem**: Either the user or API keys are incorrect, or the API key has expired. **Solution**: Check the user and API keys in the request. If the user key was entered accurately, then submit a request for a new API key. ### Error Code: `2` **Message**: Invalid action **Problem**: The requested operation wasn’t recognized by the API. **Solution**: Verify that the requested operation is valid for the target object type. If that operation is allowed, then check for misspellings and other typos. ### Error Code: `3` **Message**: Invalid prospect ID **Problem**: Account Engagement couldn’t find a match for the provided prospect ID. **Solution**: Verify that the prospect ID is accurate. ### Error Code: `4` **Message**: Invalid prospect email address **Problem**: Account Engagement couldn’t find a prospect with the provided email address (for read, update, or delete), or the prospect email address is too long (> 255 characters) or has invalid syntax (for create/upsert). See [Allowed Characters in Email Addresses](https://help.salesforce.com/articleView?id=pardot_emails_allowed_characters.htm) for email address verification. **Solution**: If running create or upsert, verify the email address is valid. If running read, update, or delete, verify that a prospect with this email address exists in your Account Engagement instance. ### Error Code: `5` **Message**: Invalid query parameters **Problem**: Account Engagement didn’t recognize any of the provided search parameters. **Solution**: Check parameter spellings. Also, ensure that the specified search parameter is supported by the API. See [Parameters to Select Prospects](https://developer.salesforce.com/docs/marketing/pardot/guide/v4/prospects-v4.md#parameters-to-select-prospects) for more details. ### Error Code: `6` **Message**: Invalid time frame **Problem**: The value of the `timeframe` search parameter wasn’t recognized. **Solution**: Check for misspellings in the `timeframe` value. Also, verify that the provided value is supported by the API. See [Parameters to Select Prospects](https://developer.salesforce.com/docs/marketing/pardot/guide/v4/prospects-v4.md#parameters-to-select-prospects) for more for supported `timeframe` values. ### Error Code: `7` **Message**: Invalid timestamp **Problem**: Account Engagement couldn’t decipher a specified timestamp. **Solution**: Verify that the timestamp adheres to GNU standards for date and time input. See [GNU Date Input Format & Syntax](http://www.gnu.org/software/tar/manual/html_node/Date-input-formats.html) for more information. Also, ensure all characters in the timestamp are URL safe. See [Parameters to Select Prospects](https://developer.salesforce.com/docs/marketing/pardot/guide/v4/prospects-v4.md#parameters-to-select-prospects) for supported values. ### Error Code: `8` **Message**: Invalid time range **Problem**: The provided start timestamp is later than the end timestamp. **Solution**: Swap the values of the timestamps. ### Error Code: `9` **Message**: A prospect with the specified email address already exists **Problem**: The provided email address is already assigned to a prospect within Account Engagement. This error can occur when a `create` request with the same email address is submitted more than one time. **Solution**: Check the existing prospect record to see if data can be merged through an `update` request. ### Error Code: `10` **Message**: Invalid user ID **Problem**: The provided user ID doesn’t exist in Account Engagement. **Solution**: Verify that the user ID was typed correctly and matches the intended user in Account Engagement. ### Error Code: `11` **Message**: Invalid user email address **Problem**: The provided user email address couldn’t be found in Account Engagement. **Solution**: Verify that the provided email address belongs to a registered Account Engagement user and that it was typed correctly. ### Error Code: `12` **Message**: Invalid group ID **Problem**: The provided group ID doesn’t exist in Account Engagement. **Solution**: Verify that the group ID was typed correctly and matches the intended group in Account Engagement. ### Error Code: `13` **Message**: One or more required parameters are missing **Problem**: One or more of the required parameters for this type of request are missing. **Solution**: Verify that all of the required parameters have been provided. Check that all parameter names were spelled accurately and as specified in [Object Field References](https://developer.salesforce.com/docs/marketing/pardot/guide/object-field-reference.md). Ensure the proper URL punctuation was used, including `?` before parameters and `&` between parameters. ### Error Code: `14` **Message**: Non-existent prospect ID; No email address provided **Problem**: The ID provided for the `upsert` wasn’t valid, and no email address was provided for a new prospect to be created. **Solution**: Verify the provided ID. If creating a prospect was intended, ensure that an email address was provided. ### Error Code: `15` **Message**: Login failed **Problem**: The provided email address, password, or user key is invalid. **Solution**: Check the provided credentials for typos. Also, ensure that the specified user account has at least "Marketing" access privileges. ### Error Code: `16` **Message**: Invalid ID **Problem**: The provided ID isn’t valid. **Solution**: Ensure that only valid integer values were provided. ### Error Code: `17` **Message**: Invalid ID range **Problem**: The provided ID range isn’t valid. **Solution**: Swap the values of the specified IDs. ### Error Code: `18` **Message**: Invalid value for profile criteria matching status **Problem**: The provided value for a profile criteria's matching status wasn’t recognized. **Solution**: Ensure that only the values `match`, `nomatch`, or `unknown` are being used. ### Error Code: `19` **Message**: Invalid value specified for sort_by **Problem**: The provided value for the `sort_by` isn’t a supported sorting order. **Solution**: Check that the specified sorting values are listed in Using (Object Type): Supported Sorting Options section for the target object. ### Error Code: `20` **Message**: Invalid value specified for sort_order **Problem**: The provided value for the `sort_order` isn’t a supported sorting order. **Solution**: Ensure that only the values `ascending` or `descending` are being used. ### Error Code: `21` **Message**: Invalid value specified for offset **Problem**: The provided value for `offset` couldn’t be interpreted as an integer. **Solution**: Check for typos that can prevent the value from being interpreted. ### Error Code: `22` **Message**: Unsupported feature in this version of the API **Problem**: The feature requested by the API call isn’t implemented in this version of the API. **Solution**: Update the request to use the necessary API version. ### Error Code: `23` **Message**: Invalid value specified for limit **Problem**: The provided value for `limit` is invalid. **Solution**: Ensure that the provided value is an integer and is no larger than 200. ### Error Code: `24` **Message**: Invalid visitor ID **Problem**: The provided visitor ID doesn’t exist in Account Engagement. **Solution**: Verify that the visitor ID was typed correctly and matches the intended visitor in Account Engagement. ### Error Code: `25` **Message**: Parameter is_starred must be true or false **Problem**: The value specified for `is_starred` couldn’t be interpreted as a boolean. **Solution**: Verify that only the values `true` or `false` were specified. ### Error Code: `26` **Message**: Parameter assigned must be true or false **Problem**: The value specified for `assigned` couldn’t be interpreted as a boolean. **Solution**: Verify that only the values `true` or `false` were specified. ### Error Code: `27` **Message**: Parameter deleted must be true or false **Problem:** The value specified for `deleted` couldn’t be interpreted as a boolean. **Solution:** Verify that only the values `true` or `false` were specified. ### Error Code: `28` **Message**: Parameter new must be true or false **Problem:** The value specified for `new` couldn’t be interpreted as a boolean. **Solution:** Verify that only the values `true` or `false` were specified. ### Error Code: `29` **Message**: Invalid value specified for score **Problem**: The value specified for `score` couldn’t be interpreted as an integer. **Solution**: Check for typos that can prevent the value from being interpreted correctly. ### Error Code: `30` **Message**: Invalid score range specified **Problem**: The provided score range isn’t valid. **Solution**: Swap the values of the specified scores. ### Error Code: `31` **Message**: Invalid combination of parameters for score **Problem**: A conflicting set of query criteria for the prospect's score has been specified. **Solution**: Make sure that `score_equal_to` isn’t being used in combination with `score_greater_than` or `score_less_than`. ### Error Code: `32` **Message**: Invalid value specified for grade **Problem**: The value specified for `grade` isn’t one of the allowed options. **Solution**: Check for typos that may prevent `grade` from being interpreted correctly. See[Parameters to Select Prospects](https://developer.salesforce.com/docs/marketing/pardot/guide/v4/prospects-v4.md#parameters-to-select-prospects) for supported values. Also, ensure that the specified grades are URL-encoded. ### Error Code: `33` **Message**: Invalid grade range specified **Problem**: The provided grade range isn’t valid. **Solution**: Swap the values of the specified grades. ### Error Code: `34` **Message**: Invalid combination of parameters for grade **Problem**: A conflicting set of query criteria for the grade has been specified. **Solution**: Make sure that `grade_equal_to` isn’t being used in combination with `grade_greater_than` or `grade_less_than`. ### Error Code: `35` **Message**: Invalid opportunity ID **Problem**: Account Engagement couldn’t find a match for the provided opportunity ID. **Solution**: Verify that the opportunity ID is accurate. ### Error Code: `36` **Message**: One or more required parameter values are missing **Problem**: Some of the parameters necessary to complete the specified API request were omitted from the request. **Solution**: Ensure that all required parameters have been included. In addition, check from typos in the parameter names. Also check that the request has been properly formatted. ### Error Code: `37` **Message**: A Salesforce connector was detected **Problem**: Your Account Engagement instance has a Salesforce connector. When a Salesforce connector is present, opportunities and prospect account cannot be modified by Account Engagement. **Solution**: **_(NOT RECOMMENDED)_** Deleting the Salesforce connector allows for opportunity modification to be done through the API. However, doing so disables synchronization with Salesforce. If a Salesforce connector is present, modifications to opportunities must be done within Salesforce. ### Error Code: `38` **Message**: Invalid campaign ID **Problem**: Account Engagement couldn’t find a match for the provided campaign ID. **Solution**: Verify that the campaign ID is accurate. ### Error Code: `39` **Message**: Invalid profile ID **Problem**: Account Engagement couldn’t find a match for the provided profile ID. **Solution**: Verify that the profile ID is accurate. ### Error Code: `40` **Message**: Invalid opportunity probability **Problem**: The value specified for `probability` isn’t valid. **Solution**: Ensure that the specified value is a number from 0 through 100 inclusive. ### Error Code: `41` **Message**: Invalid probability range specified **Problem**: The specified probability range isn’t valid. **Solution**: Ensure that the specified values are numbers from 0 through 100, inclusive. It might be necessary to swap the values of the specified probabilities. ### Error Code: `42` **Message**: Invalid opportunity value **Problem**: The value specified for `value` is not valid. **Solution**: Ensure that the specified value is a non-negative number. ### Error Code: `43` **Message**: Invalid opportunity value range specified **Problem**: The specified value range is not valid. **Solution**: Ensure that the specified values are non-negative numbers. It might be necessary to swap the specified values. ### Error Code: `44` **Message**: The provided prospect_id and prospect_email parameters do not match **Problem**: The specified `prospect_email` and `prospect_id` parameters do not correspond to the same prospect. **Solution**: Ensure that the specified email address and the ID both correspond to the desired prospect. Note: Typically, only one of these parameters is required. Consider omitting one of them. ### Error Code: `45` **Message**: The provided user_id and user_email parameters do not match **Problem**: The specified `user_id` and `user_email` parameters do not correspond to the same user. **Solution**: Ensure that the specified email address and the ID both correspond to the desired user. (Note: Typically, only one of these parameters is required. Consider omitting one of them.) ### Error Code: `46` **Message**: This API user lacks sufficient permissions for the requested operation **Problem**: The currently authenticated API user doesn't have the necessary permissions to perform the requested operation. **Solution**: Some API operations are only available to users with Administrative permissions. If the requested operation has such a requirement, reauthenticate as an administrative user and resubmit the request. See the [Authentication](https://developer.salesforce.com/docs/marketing/pardot/guide/authentication.md) section for more information. ### Error Code: `47` **Message**: Multiple assignment targets were specified **Problem**: More than one object was specified as a target for this `ASSIGN` request. For example, both a group and user were specified as targets of a prospect assignment. **Solution**: Ensure that only one target is specified when submitting an `ASSIGN` request. ### Error Code: `48` **Message**: Invalid visit ID **Problem**: The provided visit ID does not exist in Account Engagement. **Solution**: Verify that the visit ID was typed correctly and matc
[...]
